(jQuery)(function($){
    var nbLetterBeforeSearch = 2;   // Nombre de lettres devant être saisi avant le lancement de la recherche
    var timeBeforeReset = 5000;     // Temps avant la mise à zéro du champ de saisie (en milliseconde)
    
    var searchString = [];
    var wordAvailable = [];
    var page = 0;
    var totalPage = 0;
    var pageGen = 0;
    var pageWord = 0;
    var codeUV = "";

    var $printSearch = $(document.getElementById("printSearch"));
    var $loadingScreen = $(document.getElementById("loadingScreen"));
    var $charAvailable = $(document.getElementById("selectChar")).find("span");

    var $tableResult = $(document.getElementById("tableResult"));
    var $totalPage = $(document.getElementById("totalPage"));
    var $currentPage = $(document.getElementById("currentPage"));
    var $page = $(document.getElementById("page"));
    var $next = $(document.getElementById("next"));
    var $prev = $(document.getElementById("prev"));
    var $noProduit = $(document.getElementById("noProduit"));
    var $delete = $(document.getElementById("delete"));
    var $result = $(document.getElementById("totalResult"));

    var $propWord = $(document.getElementById("propWord"));
    var $propWordWrap = $(document.getElementById("propWordWrap"));
    var $nextWord = $(document.getElementById("nextWord"));
    var $prevWord = $(document.getElementById("prevWord"));
    var $layout = $(document.getElementById("printGeneriqueLayout"));
    var $searchName = $(document.getElementById("searchName"));

    var $generiqueResult = $(document.getElementById("generiqueResult"));
    var $totalPageGen = $(document.getElementById("totalPageGen"));
    var $currentPageGen = $(document.getElementById("currentPageGen"));
    var $pageGen = $(document.getElementById("currentPageGen"));
    var $nextGen = $(document.getElementById("nextGen"));
    var $prevGen = $(document.getElementById("prevGen"));
    var $totalGen = $(document.getElementById("totalGen"));
    
    // Initialisation
    $layout.hide();
    $loadingScreen.hide();
    $propWordWrap.hide();
    manageChar("on");
    emptyAll();

    // Click sur le bouton "Backspace" (à droite de la recherche)
    $(document.getElementById("delete")).click(function(){
        if(!$(this).hasClass("deactivate")) {
            searchString.pop();
            printSearch();
            page = 0;
            if(searchString.length === 0) {
                emptyAll();
                manageLetters();
            }
            else {
                getProduit();
            }
        }
    });

    // Click sur le bouton "Effacer"
    $(document.getElementById("deleteAll")).click(function(){
    	searchString = [];
    	printSearch();
    	emptyAll();
    	manageLetters();
    });

    // Click sur le bouton ">" (Mots proposés)
    $nextWord.click(function(){
        if(!$(this).hasClass("deactivate"))  {
            pageWord = pageWord + 4;
            printWords();
        }
    });

    // Click sur le bouton "<" (Mots proposés)
    $prevWord.click(function(){
        if(!$(this).hasClass("deactivate")) {
            pageWord = pageWord - 4;
            printWords();
        }
    });

    // Click sur le bouton "Suivant"
    $next.click(function(){
        if(!$(this).is(":disabled") && page < totalPage) {
            page++;
            getProduit();
        }
    });

    // Click sur le bouton "Précédent"
    $prev.click(function(){
        if(!$(this).is(":disabled")) {
            page--;
            getProduit();
        }
    });

    // Click sur le bouton "Suivant" (Générique)
    $nextGen.click(function(){
        if(!$(this).is(":disabled")) {
            pageGen++;
            getGenerique();
        }
    });

    // Click sur le bouton "Précédent" (Générique)
    $prevGen.click(function(){
        if(!$(this).is(":disabled")) {
            pageGen--;
            getGenerique();
        }
    });

    // Click sur la croix pour fermer le layout
    $(document.getElementById("closeLayout")).click(function(){
        $layout.hide();
    });
    
    // Code flashé depuis l'accueil
    if($("#searchFromIndex").val() !== "") {
        searchString = $("#searchFromIndex").val().split(',');
        getProduit();
    }

    /**
     * Gère la liste de caractères.
     * Active ou non le click sur les caractères
     * @param {String} cmd
     */
    function manageChar(cmd) {
    	if(cmd === undefined) {
            cmd = "on";
    	}

    	if(cmd === "on")  {
            $charAvailable.on("click.selectChar", function(){
                page = 0;
                var letter;
                if($(this).data("text")) {
                    letter = " ";
                }
                else {
                    letter = $(this).text();
                }

                if(!$(this).hasClass("disabled")) {
                    searchString.push(letter);
                    printSearch();
                    if(searchString.length >= nbLetterBeforeSearch) {
                        getProduit();
                    }
                }
            });
    	}
    	else if(cmd === "off") {
            $charAvailable.off(".selectChar");
    	}
    }

    /**
     * Met à jour le texte dans la zone de recherche
     */
    function printSearch() {
        $printSearch.val(searchString.join(""));
    }

    /**
     * Récupère la liste des produits correspondant à la recherche et les affiche
     */
    function getProduit() {
    	$.ajax({
            method: "POST",
            url: "./ajax_response.php",
            dataType: "JSON",
            beforeSend: function() {
                $loadingScreen.show();
                manageChar("off");
                $delete.addClass("deactivate");
            },
            data: {
                searchString : searchString.join(""),
                offset: page
            },
            success: function(data) {

                manageLetters(data.allowed);
                $delete.removeClass("deactivate");

                $totalPage.text(data.totalPage);
                totalPage = data.totalPage;
                $currentPage.text(page + 1);
                $page.show();
                $result.show();
                $noProduit.hide();
                if(page === 0 && (page + 1) !== parseInt(data.totalPage)) {
                    $next.removeAttr("disabled");
                    $prev.attr("disabled", "disabled");
                }
                else if ((page + 1) === parseInt(data.totalPage)) {
                    $next.attr("disabled", "disabled");
                    $prev.attr("disabled", "disabled");
                    if(page > 0) {
                        $prev.removeAttr("disabled");
                    }
                }
                else if (page > 0) {
                    $next.removeAttr("disabled");
                    $prev.removeAttr("disabled");
                }

                var resultText = data.totalResult > 1 ? " résultats" : " résultat";
                $result.text(data.totalResult + resultText);

                if(data.wordProp.length > 0) {
                    wordAvailable = data.wordProp;
                    pageWord = 0;
                    printWords();
                    $propWordWrap.show();
                }
                else {
                    $propWordWrap.hide();
                }

                var produitLen = data.produits.length;
                $(document.getElementById("tableResult")).find("div").remove();

                for(var i = 0; i < produitLen; i++) {
                    //var isEan = $.trim(data.produits[i].ean) === "" ? "\xA0" : data.produits[i].ean;
                    //var isCip = $.trim(data.produits[i].cip13) === "" ? "\xA0" : data.produits[i].cip13;
					var isTaux = $.trim(data.produits[i].TR_theorique) === "" ? "0" : data.produits[i].TR_theorique;
					var isHonoraire = data.produits[i].mt_honoraire === "0.00" ? "" : " (" + data.produits[i].mt_honoraire + ")";
					var generique;
                    if(data.produits[i].ref === 1) {
                        generique = '<button type="button" data-codeuv="' + data.produits[i].code_uv + '">Voir la liste</button>';
                    }
                    else if (data.produits[i].gen === 1) {
                        generique = '<button type="button" data-codeuv="' + data.produits[i].code_uvref + '">Voir la liste</button>';
                    }
                    else {
                        generique = "";
                    }
                    var isStock = data.produits[i].nb_stock > 0 ? "Oui" : "Non";
                    //$('<div class="onerow">' +
                    //    '<div class="col3">' + data.produits[i].nom_prod + '</div>' +
                    //    '<div class="col3">' + isCip + ' / ' + isEan + '</div>' +
                    //    '<div class="col2 center-text">' + data.produits[i].prix_ttc + ' €</div>' +
                    //    '<div class="col2 center-text ' + (isStock === "Non" ? "noStock" : "inStock") + '">' + isStock + '</div>' +
                    //    '<div class="col2 last">' + generique + '</div>' + 
                    //    '<div class="clearfix"></div>' +
                    //'</div>').appendTo($tableResult);
					
					var isTarifTTC = data.produits[i].prix_ttc + ' €' + isHonoraire;
					if (isStock==='Non' && (data.produits[i].code_acte==='PHN' || data.produits[i].code_acte ==='')) { isTarifTTC = 'Nous consulter'; }
                    
					$('<div class="onerow">' +
                        '<div class="col4">' + data.produits[i].nom_prod + '</div>' +
                        '<div class="col2 center-text">' + isTarifTTC + '</div>' +
                        '<div class="col1 center-text">' + data.produits[i].code_acte + '</div>' +
						'<div class="col1 center-text">' + isTaux + '%</div>' +
                        '<div class="col2 center-text ' + (isStock === "Non" ? "noStock" : "inStock") + '">' + isStock + '</div>' +
                        '<div class="col2 last">' + generique + '</div>' + 
                        '<div class="clearfix"></div>' +
                    '</div>').appendTo($tableResult);                }

                activateGenerique();
                $loadingScreen.hide();
                manageChar("on");
                timerNewScan = setTimeout(function(){
                    isNewScan = true;
                }, timeBeforeReset);
            },
            error: function() {
                alert("Impossible de récupérer les produits correspondant à votre recherche.\nVeuillez réessayer ultérieurement");
                $loadingScreen.hide();
                document.location.reload(true);
            }
    	});
    }

    /**
     * Active un caractère s'il est dans le tableau allowed
     * Sinon, désactive ce caractère
     * @param {Array} allowed
     */
    function manageLetters(allowed) {
    	if(searchString.length === 0) {
            $(document.getElementById("selectChar")).find("span").removeClass("disabled").find("img").attr("src", "./img/space.png");
    	}
    	else {
            var $letters = $(document.getElementById("selectChar")).find("div span");
            var lettersLen = $letters.length;
            for(var i = 0; i < lettersLen; i++) {
                var $letter = $($letters[i]);
                if(!$letter.data("text")) {
                    var letter = $letter.text();
                    if(!isAllowed(letter, allowed)) {
                        $letter.addClass("disabled");
                    }
                    else {
                        $letter.removeClass("disabled");
                    }
                }
                else {
                    if(!isAllowed(" ", allowed)) {
                        $letter.addClass("disabled");
                        $letter.find("img").attr("src", "./img/space_disabled.png");
                    }
                    else {
                        $letter.removeClass("disabled");
                        $letter.find("img").attr("src", "./img/space.png");
                    }
                }
            }
    	}
    }

    /**
     * Vérifie que letter se trouve dans allowed
     * @param {String} letter
     * @param {Array} allowed
     * @return Boolean
     */
    function isAllowed(letter, allowed) {
		var allowedLen = allowed.length;
		for(var i = 0; i < allowedLen; i++) {
			if(letter === allowed[i]) {
				return true;
			}
		}
		return false;
	}

	/**
	 * Remet tout à zéro
	 */
	function emptyAll() {
		page = 0;
		$tableResult.find(".onerow:not(#header)").remove();
		$totalPage.text("");
		$currentPage.text("");
		$page.hide();
        $result.hide();
		$next.attr("disabled", "disabled");
		$prev.attr("disabled", "disabled");
		$noProduit.show();
        $propWordWrap.hide();
	}

    /**
     * Affiche les propositions de mots
     */
    function printWords() {
        var max = pageWord + 4;
        var outOfArray = false;
        $propWord.empty();
        if(pageWord === 0) {
            $prevWord.addClass("deactivate").html("&nbsp;");
        }
        else {
            $prevWord.removeClass("deactivate").text("<");
        }

        for(var i = pageWord; i < max; i++) {
            if(wordAvailable[i]) {
                if(i === max - 1) {
                    $('<div class="col3 last">' + wordAvailable[i] + '</div>').appendTo($propWord);
                }
                else {
                    $('<div class="col3">' + wordAvailable[i] + '</div>').appendTo($propWord);
                }
            }
            else {
                outOfArray = true;
            }
        }

        if(outOfArray || i === wordAvailable.length) {
            $nextWord.addClass("deactivate").html("&nbsp;");
        }
        else {
            $nextWord.removeClass("deactivate").text(">");
        }
        addClickWord();
    }

    /**
     * Met l'évènement onClick sur les mots proposés
     */
    function addClickWord() {
        $propWord.find("div").click(function(){
            var lastIndex = searchString.lastIndexOf(" ");
            if (lastIndex === -1) {
                searchString = $(this).text().split("");
            }
            else {
                searchString = searchString.splice(0, lastIndex + 1);
                var tmp = $(this).text().split("");
                var tmpLen = tmp.length;
                for(var i = 0; i < tmpLen; i++) {
                    searchString.push(tmp[i]);
                }
            }
            searchString.push(" ");
            page = 0;
            printSearch();
            getProduit();
            $propWordWrap.hide();
        });
    }

    /**
     * Affiche le layout avec les génériques d'un produit
     */
    function activateGenerique() {
        $(document.getElementById("tableResult")).find("button").click(function(){
            codeUV = $(this).data("codeuv");
            var produit = $(this).parent().parent().find("div:first-child").text();
            $searchName.text(produit);
            pageGen = 0;
            getGenerique();
        });
    }

    /**
     * Créer le tableau de générique
     */
    function getGenerique() {
        $.ajax({
            url: "./generique.php",
            method: "POST",
            dataType: "JSON",
            data: {
                code_uv: codeUV,
                offset: pageGen
            },
            success: function(data) {
                $generiqueResult.empty();
                var produitLen = data.produit.length;
                for(var i = 0; i < produitLen; i++) {
                    var isEan = $.trim(data.produit[i].ean) === "" ? "\xA0" : data.produit[i].ean;
                    var isCip = $.trim(data.produit[i].cip13) === "" ? "\xA0" : data.produit[i].cip13;
					var isTaux = $.trim(data.produit[i].TR_theorique) === "" ? "0" : data.produit[i].TR_theorique;
                    var isStock = data.produit[i].nb_stock > 0 ? "Oui" : "Non";
					var isActe = $.trim(data.produit[i].code_acte) === "" ? "PHN" : data.produit[i].code_acte;
					var isHonoraire = data.produit[i].mt_honoraire === "0.00" ? "" : " (" + data.produit[i].mt_honoraire + ")";
					
                    $('<div class="onerow">' +
                        '<div class="col4">' + data.produit[i].nom_prod + '</div>' +
                        '<div class="col2 center-text">' + data.produit[i].prix_ttc + ' €' + isHonoraire + '</div>' +
                        '<div class="col2 center-text">' + isActe + '</div>' +
						'<div class="col2 center-text">' + isTaux + '%</div>' +
                        '<div class="col2 center-text last ' + (isStock === "Non" ? "noStock" : "inStock") + '">' + isStock + '</div>' +
                        '<div class="clearfix"></div>' +
                    '</div>').appendTo($generiqueResult);
                }

                if(pageGen === 0 && (pageGen + 1) !== parseInt(data.totalPage)) {
                    $nextGen.removeAttr("disabled");
                    $prevGen.attr("disabled", "disabled");
                }
                else if ((pageGen + 1) === parseInt(data.totalPage)) {
                    $nextGen.attr("disabled", "disabled");
                    if(pageGen > 0) {
                        $prevGen.removeAttr("disabled");
                    }
                    else {
                        $prevGen.attr("disabled", "disabled");
                    }
                }
                else if (pageGen > 0) {
                    $nextGen.removeAttr("disabled");
                    $prevGen.removeAttr("disabled");
                }

                var txtTotal = data.total > 1 ? " produits trouvés" : " produit trouvé";
                $totalGen.text(data.total + txtTotal);
                $totalPageGen.text(data.totalPage);
                $pageGen.text(pageGen + 1);

                $layout.show();
            },
            error: function() {
                alert("Erreur lors de la récupération des génériques.\nVeuillez réessayer ultérieurement");
                document.location.reload(true);
            }
        });
    }

    /* GESTION DE LA SAISIE DU CODE BARRE PAR LE LECTEUR */
    var timer = 0;
    var timerNewScan = 0;
    var isNewScan = false;
    $(window).on("keydown", function(e){
        var keyToBlock = [38,40,13,27,8];
        if(keyToBlock.indexOf(e.which) !== -1) {
            e.preventDefault();
            e.stopImmediatePropagation();
            if($("#printGenerique").is(":visible")) {
                if(e.which === 38) {
                    $("#closeLayout").click();
                }
                else if (e.which === 40) {
                    $("#prevGen").click();
                }
                else if (e.which === 13) {
                    $("#nextGen").click();
                }
            }
            else {
                if(e.which === 38) {
                    $("#accueil").click();
                }
                else if (e.which === 40) {
                    $("#prev").click();
                }
                else if (e.which === 13) {
                    $("#next").click();
                }
                else if (e.which === 27) {
                    $("#deleteAll").click();
                }
                else if (e.which === 8) {
                    clearTimeout(timerNewScan);
                    searchString.pop();
                    printSearch();
                    page = 0;
                    if (searchString.length === 0) {
                        emptyAll();
                        manageLetters();
                    }
                    else {
                        if (searchString.length >= nbLetterBeforeSearch) {
                            getProduit();
                        }
                    }
                }
            }
        }
    });

    $(window).on("keypress", function(e){
        if(e.charCode !== 0) {
            if(isNewScan) {
                searchString = [];
                isNewScan = false;
            }
            searchString.push(String.fromCharCode(e.charCode).toUpperCase());
            printSearch();

            clearTimeout(timer);
            clearTimeout(timerNewScan);
            timer = setTimeout(function() {
                if(searchString.length >= nbLetterBeforeSearch) {
                    getProduit();
                }
            }, 1000);
        }
    });

});