<?php
// FONCTIONS PHP

function NettoieDataMatrix($codeData) {
    $tmp = $codeData;
    // On filtre les codes datamatrix avec les parenthèses
    if (substr($codeData, 0, 4) == '(01)') {
        $codeData = str_replace('(', '', str_replace(')', '', $codeData));
    }
    // On filtre les codes datamatrix avec des caractères de contrôle
    For ($i = 0; $i <= strlen($codeData); $i++) {
        If (chr(substr($codeData, $i, 1)) >= 32) {
            $tmp = $tmp + substr($codeData, i, 1);
        }
    }
    // Dans certains codes datamatrix on a une zone 21 qu'il vaut mieux faire disparaitre
    If (substr($tmp, 17, 2) == '21') {
        $pos = strrpos($tmp, '17', 17); // InStr(17, tmp, "17")
        $pos2 = strrpos($tmp, '10', 17); // InStr(17, tmp, "10")
        If (($pos2 < $pos) && ($pos2 != 0)) {
            $pos = $pos2;
        }
        $pos2 = strrpos($tmp, '11', 17); //InStr(17, tmp, "11")
        If ((pos2 < pos) && (pos2 != 0)) {
            $pos = $pos2;
        }
        If ($pos != 0) {
            $tmp = substr($tmp, 0, 16) + subtr($tmp, $pos);
        } Else {
            $tmp = substr($tmp, 0, 16);
        }
    }
    return($tmp);
}

Function IsCIPPossibleouDataMatrix($code) {
    if (is_numeric(substr(NettoieDataMatrix($code), 0, 20))) {
        return true;
    } else {
        return false;
    }
}

function IsCodeDatamatrix($code) {
    // Code datamatrix avec date de fabrication
    //    (01)03400935955838(11)101200(17)131100(10)0GX7A
    // Code datamatrix sans date de fabrication
    //    (01)03400935955838(17)131100(10)0GX7A
    // (01) : code cip13
    // (10) : no de lot
    // (11) : date de fabrication
    // (17) : date de péremption

    $code = NettoieDataMatrix($code);

    If ((strlen($code) > 20) && (substr($code, 0, 2) == '01') || (substr($code, 0, 2) == '03')) {
        $decale = 0;
        If (substr($code, 17, 2) == '17') {
            $decale = 0;
        } elseif (substr($code, 16, 2) == '17') {
            $decale = -1;
        } // Pas de Date de fabrication - avec cip13 sans zéro devant
        elseif ((substr($code, 17, 2) == '11') Or ( substr($code, 17, 2) == '10')) {
            $decale = 8;
        } // Date de fabrication - avec cip13 avec zéro devant

        If (substr($code, 17 + $decale, 2) != '17') {
            If (substr($code, 17 + $decale - 2, 2) == '17') {
                $decale = $decale - 2;
            } Elseif (substr($code, 17 + $decale - 3, 2) == '17') {
                $decale = $decale - 3;
            }
        }
    } ElseIf ((substr($code, 16, 2) == '11') || (substr($code, 16, 2) == '10')) {
        $decale = 7;
        If (substr($code, 17 + $decale, 2) != '17') {
            If (substr($code, 17 + $decale - 2, 2) == '17') {
                $decale = $decale - 2;
            } ElseIf (substr($code, 17 + $decale - 3, 2) == '17') {
                $decale = $decale - 3;
            }
        }
    } ElseIf ((substr($code, 15, 2) == '17') && (substr($code, 0, 2) == '03')) {
        $decale = -2;
    }

    $result = '';

    If (substr($code, 17 + $decale, 2) == '17') {
        if (($decale == 7) || ($decale == -1)) {
            $result = substr($code, 3, 13);
        } elseif ($decale == -2) {
            $result = substr($code, 2, 13);
        } else {
            $result = substr($code, 4, 13);
        }
    }

    return ($result);
}

function search_produit($codeprod) {
    // Retrouve le produit à partir du code passé en parametre
    // qui peut être du datamatrix, du cip13, de l'ean ou du cip7
    // Retourne le résultat sous la forme : code_uv##Ddate_perim##Lnolot
    $retour = "";
    if (strlen($codeprod) <= 7) {
            while (strlen($codeprod) < 7) $codeprod = '0'.$codeprod;
            $sql = "select * from produit where cip='".$codeprod."'";
            /* MS SQL */
            $result = sql_query($sql) or die('Erreur SQL !<br>'.$sql);
            if ($row = sql_fetch_array($result)) {
            
            /* SQL SRV */
            //$result = sqlsrv_query(DB,$sql) or die('Erreur SQL !<br>'.$sql);
            //if ($row = sqlsrv_fetch_array($result)) {
                    $retour = $row['code_uv'];
            }			
    } else if (strlen($codeprod) <= 13) {
            while (strlen($codeprod) < 13) $codeprod = '0'.$codeprod;
            $sql = "select * from produit where ean='".$codeprod."' or cip13='".$codeprod."'";
            
            /* MS SQL */
            $result = sql_query($sql) or die('Erreur SQL !<br>'.$sql);
            if ($row = sql_fetch_array($result)) {

            /* SQL SRV */
            //$result = sqlsrv_query(DB,$sql) or die('Erreur SQL !<br>'.$sql);
            //if ($row = sqlsrv_fetch_array($result)) {
                    $retour = $row['code_uv'];
            }
    } else if (strlen($codeprod) < 20) {	// Code LPP
            $sql = "select * from produit where cip='".substr($codeprod,-7)."'";
            
            /* MS SQL */
            $result = sql_query($sql) or die('Erreur SQL !<br>'.$sql);
            if ($row = sql_fetch_array($result)) {
            
            /* SQL SERVER */
            //$result = sqlsrv_query(DB,$sql) or die('Erreur SQL !<br>'.$sql);
            //if ($row = sqlsrv_fetch_array($result)) {
                    $retour = $row['code_uv'];
            }			
    } else if (strlen($codeprod) == 20) {	// Code à 20 positions
            $sql = "select * from produit where cip='".substr($codeprod,0,7)."' or cip='".substr($codeprod,5,7)."'";
            
            /* MS SQL */
            $result = sql_query($sql) or die('Erreur SQL !<br>'.$sql);
            if ($row = sql_fetch_array($result)) {
            
            /* SQL SRV */
            //$result = sqlsrv_query(DB,$sql) or die('Erreur SQL !<br>'.$sql);		
            //if ($row = sqlsrv_fetch_array($result)) {
                    $retour = $row['code_uv'];
            }			
    } else if (strlen($codeprod) <= 22) {	// Code à 20 positions
            while (strlen($codeprod) < 22) $codeprod = '0'.$codeprod;
            $sql = "select * from produit where ean='".substr($codeprod,1,13)."' or cip13='".substr($codeprod,1,13)."'";
            
            /* MS SQL */
            $result = sql_query($sql) or die('Erreur SQL !<br>'.$sql);
            if ($row = sql_fetch_array($result)) {
            
            /* SQL SRV */
            //$result = sqlsrv_query(DB,$sql) or die('Erreur SQL !<br>'.$sql);
            //if ($row = sqlsrv_fetch_array($result)) {
                    $retour = $row['code_uv'];
            }			
    } else if (substr($codeprod,0,2) == "01") {	// S'agit-il d'un code datamatrix ?
    // 01034009333595911714103110N2558
    // 0103400934867996171310281111102810F3873
    // 01034009379160591714120010ML6003
    // 012345678901234567890123456789012345678 --- réglette
            $code_uv = "";
            $decale = 0;
            if (substr($codeprod, 15, 2) == "17") { // Pas de Date de fabrication - avec cip13 sans zéro devant
                    $decale = -1;
            } else if (substr($codeprod, 16, 2) == "17") { // Pas de Date de fabrication - avec cip13 avec zéro devant
                    $decale = 0;
            } else if (substr($codeprod, 16, 2) == "11" or substr($codeprod, 16, 2) == "10") { // Date de fabrication - avec cip13 avec zéro devant
                    $decale = 8;
            } else if (substr($codeprod, 15, 2) == "11" or substr($codeprod, 15, 2) == "10") {  // Date de fabrication - avec cip13 sans zéro devant
                    $decale = 7;
            }
            if (substr($codeprod, 16 + $decale, 2) == "17") {
                    if ($decale == 7 Or $decale == -1) {
                            $cip13 = substr($codeprod, 2, 13);
                    } else {
                            $cip13 = substr($codeprod, 3, 13);
                    }
                    $sql = "select * from produit where cip13='".$cip13."'";
                    
                    /* MS SQL */
                    $result = sql_query($sql) or die('Erreur SQL !<br>'.$sql);
                    if ($row = sql_fetch_array($result)) {
                    
                    /* SQL SRV */
                    //$result = sqlsrv_query(DB,$sql) or die('Erreur SQL !<br>'.$sql);
                    //if ($row = sqlsrv_fetch_array($result)) {
                            $retour = $row['code_uv'];
                    }
            }
    }
    return($retour);
}

// Honoraire de dispensation
// On cherche par index produit Pharmavitale
/*function mt_honoraire($codeacte, $flgrandcond) {
	if ($codeacte == "PH1" or $codeacte == "PH2" or $codeacte == "PH4" or $codeacte == "PH7") {
		// Produit avec honoraire de dispensation ?
		$code_acte_honoraire = "H";
		if ($flgrandcond != "1") {
			$code_acte_honoraire .= "D";
		} else {
			$code_acte_honoraire .= "G";
		}
		$code_acte_honoraire .= substr($codeacte,-1);
		$sql = "select montant from tarif_honoraires where code_acte='".$code_acte_honoraire."' ".
					"and date_debut <= getdate() and (date_fin is null or date_fin > getdate()) order by date_debut desc";
		$result = sql_query($sql);
		if ($row = sql_fetch_array($result)) {
			return($row['montant']*0.01);
		} else {
			return(0);
		}
	} else {
		return(0);
	}
}
*/