<?php
/**
* @desc Encode toutes les valeurs du tableau d'entrée en UTF-8, peu importe le nombre de niveau
* @param    $input  :   array, seul les String sont traités
* @return   void
*/
function utf8_encode_deep(&$input) {
        if (is_string($input)) {
            $input = trim(utf8_encode($input));
        } else if (is_array($input)) {
            foreach ($input as &$value) {
                utf8_encode_deep($value);
            }

            unset($value);
        } else if (is_object($input)) {
            $vars = array_keys(get_object_vars($input));

            foreach ($vars as $var) {
                utf8_encode_deep($input->$var);
            }
        }
    }
    
/**
 * @desc Decode toutes les valeurs du tableau d'entrée en UTF-8, peu importe le nombre de niveau
 * @param    $input  :   array, seul les String sont traités
 * @return   void
 */
function utf8_decode_deep(&$input) {
        if (is_string($input)) {
            $input = trim(utf8_decode($input));
        } else if (is_array($input)) {
            foreach ($input as &$value) {
                utf8_decode_deep($value);
            }

            unset($value);
        } else if (is_object($input)) {
            $vars = array_keys(get_object_vars($input));

            foreach ($vars as $var) {
                utf8_decode_deep($input->$var);
            }
        }
    }
?>